#include <stdio.h>
#include <stdlib.h>
#include "iso2709.h"

void print_help() {
	printf("Usage: iso2709 <infile>\n");
}

int main(int argc, char** argv) {

	if (argc != 2) {
		print_help();
		exit(EXIT_FAILURE);
	}

	fprintf(stdout, "%s\n", argv[1]);

	FILE *input = fopen(argv[1], "r");
	if (!input) {
		fprintf(stdout, "Can't read file\n");
		fclose(input);
		return EXIT_FAILURE;
	}

	iso2709_parse_file(input, stdout);
	fclose(input);
	fflush(stdout);

	return EXIT_SUCCESS;
}
