#include <stdio.h>
#include <stdlib.h>
#include "iso2709.h"

void test_file(const int expected, const char* filename) {
	FILE* input = fopen(filename, "r");
	if (!input) {
		printf("Can't open file: %s\n",filename);
		return;
	}
	printf("Testing file: %s\t", filename);
	int result = iso2709_parse_file(input, stderr);
	printf("%s\n", result == expected ? "PASSED" : "FAILED");
	fclose(input);
}


int main() {
	printf("Test in  NULL: \t%s\n", 0 != iso2709_parse_file(NULL, stderr) ? "PASSED" : "FAILED");
	FILE* in_file = fopen("samples/sample.mrc", "r");
	if ( in_file ) {
		printf("Test out NULL: \t%s\n", 0 != iso2709_parse_file(in_file, NULL) ? "PASSED" : "FAILED");
	}
	fclose(in_file);	

	test_file(4, "test_files/random1.mrc");
	test_file(4, "test_files/random2.mrc");
	test_file(2, "test_files/random3.mrc");
	test_file(8, "test_files/field_invalid.mrc");
	test_file(5, "test_files/offset_invalid.mrc");
	test_file(8, "test_files/invalid.mrc");
	
	test_file(0, "test_files/long.mrc");
	test_file(0, "samples/sample.mrc");
	test_file(0, "samples/large.mrc");
	test_file(0, "test_files/white_spaces_valid.mrc");



	return EXIT_SUCCESS;
}
